/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import pulpcore.Stage;
import pulpcore.animation.Fixed;
import pulpcore.image.CoreGraphics;
import pulpcore.image.CoreImage;
import pulpcore.sprite.Sprite;

/**
 *
 * @author Julio Cachay
 */
public class mapa extends Sprite {

    private CoreImage[][] MapaTile;
    private int TileWidth;
    private int TileHeight;
    private int numTilesLargo;
    private int numTilesFilas;
    public final Fixed vistaX = new Fixed(this);
    public final Fixed vistaY = new Fixed(this);

    public mapa(CoreImage[][] MapaTile, int Width, int Height) {
        //lo colocamos a la izquierda y en la parte de abajo
        super(0, Stage.getHeight() - Height, Stage.getWidth(), Stage.getHeight());
        this.MapaTile = MapaTile;
        this.TileWidth = Width;
        this.TileHeight = Height;
        numTilesLargo = MapaTile.length;
        numTilesFilas = MapaTile[0].length;
        // para manejo de posiciones exactas en píxeles.
        pixelSnapping.set(true);
    }

    //El largo del mapa
    public int getMapWidth() {
        return TileWidth * numTilesLargo;
    }

    //El alto del mapa
    public int getMapHeight() {
        return TileHeight * numTilesFilas;
    }

    //Altura de la tierra
    public int tierraFirme(){
        return Stage.getHeight() - TileHeight;
    }

    //se mueve?
    public boolean isScrolling() {
        return vistaX.isAnimating() || vistaY.isAnimating();
    }

    @Override
    public void update(int elapsedTime) {
        super.update(elapsedTime);
        vistaX.update(elapsedTime);
        vistaY.update(elapsedTime);
    }

    //sobreescribimos la funcion drawSprite para dibujar el mapa
    @Override
    protected void drawSprite(CoreGraphics g) {
        int y = vistaY.getAsIntFloor();
        for (int j = 0; j < numTilesFilas; j++) {
            int x = vistaX.getAsIntFloor();
            for (int i = 0; i < numTilesLargo; i++) {
                g.drawImage(MapaTile[i][j], x, y);
                x += TileWidth;
            }
            y += TileHeight;
        }
    }
}